
/*	ETYPE:		Global function type definitions for
			MicroEMACS 3.9

                        written by Daniel Lawrence
                        based on code by Dave G. Conroy,
                        	Steve Wilhite and George Jones
$Header: etype.h 2.3 92/03/09 $
$Log:	etype.h,v $
 * Revision 2.3  92/03/09  11:15:02  phil
 * Changes for PTX
 * 
 * Revision 2.2  90/05/08  13:47:08  dan
 * Another attempt to fix bugs in key binding.  It seems that many
 * routines check for k_ptr.fp == NULL when looking for the end of
 * the binding table.  If k_ptr is not a union, then this causes
 * macros-to-key bindings to be ignored! Fix: for non-ANSI compilers
 * macro-to-key bindings have k_ptr.fp = bindbuf (a dummy function).
 * 
 * Revision 2.1  89/12/15  13:57:39  dan
 * Add macro breakin stuff...
 * 
 * Revision 2.0  89/11/21  11:20:37  dan
 * IBM PC and other modifications made by Alan Philips
 * 
 * Revision 1.6  89/09/13  15:28:44  dan
 * Enhance backup file name generation
 * 
 * Revision 1.5  89/08/29  15:38:13  dan
 * Add expansion of leading ~ in file names
 * 
 * Revision 1.4  89/08/25  14:00:08  dan
 * Miscellaneous Mods to make compatable with GNU c
 * 
 * Revision 1.3  89/08/18  16:40:20  dan
 * Add Lancaster-style CTRL-B and CTRL-F prefix support, turned on via
 * the EXTRAKEYS option.
 * 
 * Revision 1.2  89/08/17  17:27:15  dan
 * Add support for GOLD prefix, if VTGOLD set
 * 
*/


/* ALL global fuction declarations */

BUFFER *PASCAL NEAR bfind();
BUFFER *PASCAL NEAR getdefb();
BUFFER *PASCAL NEAR getcbuf();
char *PASCAL NEAR bytecopy();
char *PASCAL NEAR complete();
char *PASCAL NEAR envval();
char *PASCAL NEAR fixnull();
char *PASCAL NEAR flook();
char *PASCAL NEAR funval();
char *PASCAL NEAR getctext();
char *PASCAL NEAR getfname();
char *PASCAL NEAR getkill();
char *PASCAL NEAR getreg();
char *PASCAL NEAR getval();
char *PASCAL NEAR gtenv();
char *PASCAL NEAR gtfilename();
char *PASCAL NEAR gtfun();
char *PASCAL NEAR gtusr();
char *PASCAL NEAR int_asc();
char *PASCAL NEAR ltos();
char *PASCAL NEAR makename();
char *PASCAL NEAR mklower();
char *PASCAL NEAR mkupper();
char *PASCAL NEAR namval();
char *PASCAL NEAR timeset();
char *PASCAL NEAR token();
char *PASCAL NEAR transbind();
char *PASCAL NEAR trimstr();
char *PASCAL NEAR xlat();
int (PASCAL NEAR *PASCAL NEAR fncmatch())();
int (PASCAL NEAR *PASCAL NEAR getname())();
int PASCAL NEAR absv();
int PASCAL NEAR amatch();
#if ! __STDC__
int PASCAL NEAR bindbuf();
#endif
int PASCAL NEAR biteq();
int PASCAL NEAR boundry();
int PASCAL NEAR cclmake();
int PASCAL NEAR checknext();
int PASCAL NEAR desfunc();
int PASCAL NEAR desvars();
int PASCAL NEAR dispvar();
int PASCAL NEAR echochar();
int PASCAL NEAR eq();
int PASCAL NEAR ernd();
int PASCAL NEAR execkey();
int PASCAL NEAR fbound();
int PASCAL NEAR fexist();
#if	LANCASTER
VOID PASCAL NEAR fisearch();
#else
int PASCAL NEAR fisearch();
#endif
int PASCAL NEAR getkey();
int PASCAL NEAR gettyp();
int PASCAL NEAR getwpos();
int PASCAL NEAR get_char();
int PASCAL NEAR match_pat();
int PASCAL NEAR mceq();
int PASCAL NEAR mcscanner();
int PASCAL NEAR mcstr();
int PASCAL NEAR nextch();
int PASCAL NEAR promptpattern();
int PASCAL NEAR readpattern();
int PASCAL NEAR reglines();
int PASCAL NEAR remmark();
int PASCAL NEAR replaces();
#if	LANCASTER
VOID PASCAL NEAR risearch();
#else
int PASCAL NEAR risearch();
#endif
int PASCAL NEAR scanmore();
int PASCAL NEAR scanner();
int PASCAL NEAR setlower();
int PASCAL NEAR setupper();
int PASCAL NEAR setvar();
int PASCAL NEAR sindex();
#if	LANCASTER
int PASCAL NEAR srindex();
#endif
int PASCAL NEAR stol();
int PASCAL NEAR svar();
int PASCAL NEAR tgetc();
int PASCAL NEAR uneat();
LINE *PASCAL NEAR lalloc();
LINE *PASCAL NEAR mouseline();
int PASCAL NEAR addline();
int PASCAL NEAR adjustmode();
int PASCAL NEAR anycb();
int PASCAL NEAR apro();
int PASCAL NEAR asc_int();
int PASCAL NEAR backchar();
int PASCAL NEAR backdel();
int PASCAL NEAR backhunt();
int PASCAL NEAR backline();
int PASCAL NEAR backpage();
int PASCAL NEAR backsearch();
int PASCAL NEAR backword();
int PASCAL NEAR bclear();
int PASCAL NEAR bindtokey();
int PASCAL NEAR bktoshell();
int PASCAL NEAR buildlist();
int PASCAL NEAR capword();
int PASCAL NEAR cbuf();
int PASCAL NEAR cbuf1();
int PASCAL NEAR cbuf10();
int PASCAL NEAR cbuf11();
int PASCAL NEAR cbuf12();
int PASCAL NEAR cbuf13();
int PASCAL NEAR cbuf14();
int PASCAL NEAR cbuf15();
int PASCAL NEAR cbuf16();
int PASCAL NEAR cbuf17();
int PASCAL NEAR cbuf18();
int PASCAL NEAR cbuf19();
int PASCAL NEAR cbuf2();
int PASCAL NEAR cbuf20();
int PASCAL NEAR cbuf21();
int PASCAL NEAR cbuf22();
int PASCAL NEAR cbuf23();
int PASCAL NEAR cbuf24();
int PASCAL NEAR cbuf25();
int PASCAL NEAR cbuf26();
int PASCAL NEAR cbuf27();
int PASCAL NEAR cbuf28();
int PASCAL NEAR cbuf29();
int PASCAL NEAR cbuf3();
int PASCAL NEAR cbuf30();
int PASCAL NEAR cbuf31();
int PASCAL NEAR cbuf32();
int PASCAL NEAR cbuf33();
int PASCAL NEAR cbuf34();
int PASCAL NEAR cbuf35();
int PASCAL NEAR cbuf36();
int PASCAL NEAR cbuf37();
int PASCAL NEAR cbuf38();
int PASCAL NEAR cbuf39();
int PASCAL NEAR cbuf4();
int PASCAL NEAR cbuf40();
int PASCAL NEAR cbuf5();
int PASCAL NEAR cbuf6();
int PASCAL NEAR cbuf7();
int PASCAL NEAR cbuf8();
int PASCAL NEAR cbuf9();
int PASCAL NEAR cex();
int PASCAL NEAR cinsert();
int PASCAL NEAR clean();
int PASCAL NEAR clrmes();
int PASCAL NEAR cmdstr();
int PASCAL NEAR copyregion();
#if	LANCASTER
VOID PASCAL NEAR crypt();
#else
int PASCAL NEAR crypt();
#endif
int PASCAL NEAR ctlxe();
int PASCAL NEAR ctlxlp();
int PASCAL NEAR ctlxrp();
#if	LANCASTER
KCODE PASCAL NEAR ctoec();
#else
int PASCAL NEAR ctoec();
#endif
int PASCAL NEAR ctrlg();
int PASCAL NEAR dcline();
int PASCAL NEAR deblank();
int PASCAL NEAR debug();
int PASCAL NEAR delbword();
int PASCAL NEAR delfword();
int PASCAL NEAR delgmode();
int PASCAL NEAR delins();
int PASCAL NEAR delmode();
int PASCAL NEAR delwind();
int PASCAL NEAR desbind();
int PASCAL NEAR deskey();
int PASCAL NEAR detab();
int PASCAL NEAR dobuf();
int PASCAL NEAR docmd();
int PASCAL NEAR dofile();
#if	LANCASTER
KCODE PASCAL NEAR ectoc();
#else
int PASCAL NEAR ectoc();
#endif
int PASCAL NEAR edinit();
int PASCAL NEAR editloop();
int PASCAL NEAR endword();
int PASCAL NEAR enlargewind();
int PASCAL NEAR entab();
int PASCAL NEAR execbuf();
int PASCAL NEAR execcmd();
int PASCAL NEAR execfile();
int PASCAL NEAR execprg();
int PASCAL NEAR execproc();
int PASCAL NEAR execprog();
int PASCAL NEAR execute();
int PASCAL NEAR expandp();
#if LANCASTER
void PASCAL NEAR fcopy_attributes(/* char *,char * */);
char * PASCAL NEAR backup_filename(/* char * */);
#endif
int PASCAL NEAR ffclose();
int PASCAL NEAR ffgetline();
int PASCAL NEAR ffputline();
int PASCAL NEAR ffropen();
int PASCAL NEAR ffwopen();
int PASCAL NEAR filefind();
int PASCAL NEAR filename();
int PASCAL NEAR fileread();
int PASCAL NEAR filesave();
int PASCAL NEAR filewrite();
int PASCAL NEAR fillpara();
int PASCAL NEAR filter();
#if	LANCASTER
VOID PASCAL NEAR findvar();
#else
int PASCAL NEAR findvar();
#endif
int PASCAL NEAR fmatch();
int PASCAL NEAR fnclabel();
int PASCAL NEAR forwchar();
int PASCAL NEAR forwdel();
int PASCAL NEAR forwhunt();
int PASCAL NEAR forwline();
int PASCAL NEAR forwpage();
int PASCAL NEAR forwsearch();
int PASCAL NEAR forwword();
int PASCAL NEAR freewhile();
int PASCAL NEAR getccol();
int PASCAL NEAR getcline();
KCODE PASCAL NEAR getcmd();
int PASCAL NEAR getfence();
int PASCAL NEAR getfile();
int PASCAL NEAR getgoal();
int PASCAL NEAR getregion();
int PASCAL NEAR getstring();
#ifdef	VTGOLD
int PASCAL NEAR gold();
#endif
#ifdef	EXTRAKEYS
int PASCAL NEAR ctlb();
int PASCAL NEAR ctlf();
#endif
int PASCAL NEAR gotobob();
int PASCAL NEAR gotobol();
int PASCAL NEAR gotobop();
int PASCAL NEAR gotoeob();
int PASCAL NEAR gotoeol();
int PASCAL NEAR gotoeop();
int PASCAL NEAR gotoline();
int PASCAL NEAR gotomark();
int PASCAL NEAR help();
int PASCAL NEAR ifile();
int PASCAL NEAR indent();
int PASCAL NEAR initchars();
int PASCAL NEAR insbrace();
int PASCAL NEAR insfile();
int PASCAL NEAR inspound();
int PASCAL NEAR insspace();
int PASCAL NEAR inword();
int PASCAL NEAR isearch();
int PASCAL NEAR ismodeline();
int PASCAL NEAR istring();
int PASCAL NEAR kdelete();
int PASCAL NEAR killbuffer();
int PASCAL NEAR killpara();
int PASCAL NEAR killregion();
int PASCAL NEAR killtext();
int PASCAL NEAR kinsert();
int PASCAL NEAR lchange();
int PASCAL NEAR ldelete();
int PASCAL NEAR ldelnewline();
int PASCAL NEAR lfree();
int PASCAL NEAR linsert();
int PASCAL NEAR linstr();
int PASCAL NEAR listbuffers();
int PASCAL NEAR lnewline();
int PASCAL NEAR long_asc();
int PASCAL NEAR lover();
int PASCAL NEAR lowerregion();
int PASCAL NEAR lowerword();
int PASCAL NEAR lowrite();
int PASCAL NEAR macarg();
int PASCAL NEAR macrotokey();
int PASCAL NEAR makelist();
int PASCAL NEAR makelit();
int PASCAL NEAR mcclear();
int PASCAL NEAR meexit();
int PASCAL NEAR meta();
#if	LANCASTER
VOID PASCAL NEAR mlerase();
#else
int PASCAL NEAR mlerase();
#endif
int PASCAL NEAR mlforce();
int PASCAL NEAR mlout();
int PASCAL NEAR mlputf();
int PASCAL NEAR mlputi();
int PASCAL NEAR mlputli();
int PASCAL NEAR mlputs();
int PASCAL NEAR mlreply();
int PASCAL NEAR mltreply();
int PASCAL NEAR mlyesno();
#if	LANCASTER
VOID PASCAL NEAR modeline();
#else
int PASCAL NEAR modeline();
#endif
int PASCAL NEAR mouseoffset();
int PASCAL NEAR movecursor();
int PASCAL NEAR movemd();
int PASCAL NEAR movemu();
int PASCAL NEAR mregdown();
int PASCAL NEAR mregup();
int PASCAL NEAR mvdnwind();
int PASCAL NEAR mvupwind();
int PASCAL NEAR namebuffer();
int PASCAL NEAR namedcmd();
int PASCAL NEAR narrow();
int PASCAL NEAR newline();
int PASCAL NEAR newsize();
int PASCAL NEAR newwidth();
int PASCAL NEAR nextarg();
int PASCAL NEAR nextbuffer();
int PASCAL NEAR nextdown();
int PASCAL NEAR nextup();
int PASCAL NEAR nextwind();
int PASCAL NEAR nullproc();
int PASCAL NEAR onlywind();
int PASCAL NEAR openline();
int PASCAL NEAR ostring();
int PASCAL NEAR outstring();
int PASCAL NEAR ovstring();
int PASCAL NEAR pipecmd();
int PASCAL NEAR prevwind();
int PASCAL NEAR putctext();
int PASCAL NEAR putline();
int PASCAL NEAR qreplace();
int PASCAL NEAR quickexit();
int PASCAL NEAR quit();
int PASCAL NEAR quote();
int PASCAL NEAR rdonly();
int PASCAL NEAR readin();
int PASCAL NEAR reform();
int PASCAL NEAR reframe();
int PASCAL NEAR refresh();
int PASCAL NEAR reposition();
int PASCAL NEAR resetkey();
int PASCAL NEAR resize();
int PASCAL NEAR resizm();
int PASCAL NEAR resterr();
int PASCAL NEAR restwnd();
int PASCAL NEAR rmcclear();
int PASCAL NEAR rmcstr();
int PASCAL NEAR rvstrcpy();
int PASCAL NEAR savematch();
int PASCAL NEAR savewnd();
int PASCAL NEAR scwrite();
int PASCAL NEAR setbit();
int PASCAL NEAR setccol();
int PASCAL NEAR setekey();
int PASCAL NEAR setfillcol();
int PASCAL NEAR setgmode();
int PASCAL NEAR setjtable();
int PASCAL NEAR setmark();
int PASCAL NEAR setmod();
int PASCAL NEAR shellprog();
int PASCAL NEAR showcpos();
int PASCAL NEAR shrinkwind();
int PASCAL NEAR spal();
int PASCAL NEAR spawn();
int PASCAL NEAR spawncli();
int PASCAL NEAR splitwind();
int PASCAL NEAR sreplace();
int PASCAL NEAR startup();
int PASCAL NEAR storemac();
int PASCAL NEAR storeproc();
int PASCAL NEAR strinc();
int PASCAL NEAR swapmark();
int PASCAL NEAR swbuffer();
int PASCAL NEAR tab();
int PASCAL NEAR trim();
int PASCAL NEAR ttclose();
int PASCAL NEAR ttflush();
int PASCAL NEAR ttgetc();
#if	LANCASTER
VOID PASCAL NEAR ttopen();
#else
int PASCAL NEAR ttopen();
#endif
int PASCAL NEAR ttputc();
int PASCAL NEAR twiddle();
int PASCAL NEAR typahead();
int PASCAL NEAR unarg();
int PASCAL NEAR unbindchar();
int PASCAL NEAR unbindkey();
int PASCAL NEAR unmark();
int PASCAL NEAR unqname();
int PASCAL NEAR updall();
int PASCAL NEAR update();
int PASCAL NEAR updateline();
int PASCAL NEAR upddex();
int PASCAL NEAR updext();
int PASCAL NEAR updgar();
int PASCAL NEAR updone();
int PASCAL NEAR updpos();
int PASCAL NEAR updupd();
int PASCAL NEAR upmode();
int PASCAL NEAR upperregion();
int PASCAL NEAR upperword();
int PASCAL NEAR upscreen();
int PASCAL NEAR upwind();
int PASCAL NEAR usebuffer();
int PASCAL NEAR varclean();
int PASCAL NEAR varinit();
int PASCAL NEAR viewfile();
int PASCAL NEAR vteeol();
int PASCAL NEAR vtfree();
#if	LANCASTER
int	PASCAL NEAR vthardscroll();
#endif
int PASCAL NEAR vtinit();
int PASCAL NEAR vtmove();
int PASCAL NEAR vtputc();
int PASCAL NEAR vttidy();
int PASCAL NEAR widen();
int PASCAL NEAR wordcount();
int PASCAL NEAR wrapword();
int PASCAL NEAR writemsg();
int PASCAL NEAR writeout();
int PASCAL NEAR yank();
int PASCAL NEAR zotbuf();
unsigned int PASCAL NEAR chcase();
KCODE PASCAL NEAR getckey();
unsigned int PASCAL NEAR stock();
KEYTAB *getbind();
WINDOW *PASCAL NEAR mousewindow();
WINDOW *PASCAL NEAR wpopup();

#if	MSDOS & TURBO
int PASCAL NEAR binary(char *, char *(PASCAL NEAR *)(), int);
#else
int PASCAL NEAR binary();
#endif

#if	COMPLET
char *PASCAL NEAR getffile();
char *PASCAL NEAR getnfile();
#endif

char PASCAL NEAR upperc();
char PASCAL NEAR lowerc();

#if	DIACRIT
int PASCAL NEAR islower();
int PASCAL NEAR isupper();
int PASCAL NEAR isletter();
#endif

#if	MAGIC
BITMAP PASCAL NEAR clearbits();
#endif

#if	DTL
CDECL NEAR mlwrite(...);
#else
#if	LANCASTER
VOID CDECL NEAR mlwrite();
#else
int CDECL NEAR mlwrite();
#endif
#endif

/* some library redefinitions */

/*
char *strcat();
char *strcpy();
char *malloc();
*/
